
 /* spo.h
    - Include File for SPO Support Routines -
    (c) 1994 by Andreas R. Kleinert
    Last changes : 14.01.1994
 */

#ifndef SPO_H
#define SPO_H


 /* ********** */
 /* SPO Header */
 /* ********** */

 /* File ID Definitions */

#define SPO_ID          "SPO Sample File V1.0"
#define SPO_ID_LEN      21                        /* len = 21 + 0 Byte */

struct SPOHeader
{
 UBYTE spo_ID [SPO_ID_LEN];

 UBYTE spo_SampleBits;      /* 8, 12, 16                            */
 UBYTE spo_StereoFlag;      /* Boolean                              */

 UBYTE spo_Channels;        /* as in AudioDevice IO-Block           */
 ULONG spo_Frequency;       /* as in AudioDevice IO-Block           */
 ULONG spo_Volume;          /* as in AudioDevice IO-Block           */

 ULONG spo_SampleLength;    /* Length of Sample in Bytes            */
};

#define SPOHEADER_SIZE (sizeof(struct SPOHeader))

#endif /* SPO_H */
